#ifndef __CJOSEPH__
#define __CJOSEPH__

#include "../Commons/GeneraGrid.h"
#include "../PolarSectors/Sector_LOR.h"
#include "../PolarSectors/Sector_2D.h"

#define MAX_VoxelCorners 4

class CJoseph : public CGrid
{
private:
	//VEC2D_double *centro; //Ja esta la variable m_Grid

	/**
	 * Variables que deberan estar declaradas
	 * en PolarSectors.h
	 *
	 * Clase desconocida CSectorLOR	
	 * Clase desconocida CSector2D
	 * ?? m_SectorMatrix	del tipo CSectorLOR
	 * ?? m_Sector2D		del tipo CSector2D
	 * 	VEC2D_double * m_VoxelCorners;
	 *  BackProject_Mtx * m_VOI_to_2D;
	 */

	// Variables
	VEC2D_double m_VoxelCorners[MAX_VoxelCorners];
	CSectorLOR * m_SectorMatrix;
	CSector2D  * m_Sector2D;

	BackProject_Mtx *m_VOI_to_2D;

public:
	CJoseph();
	~CJoseph();
	int Polar2Cartesian(int ** Cartesian, int ** Polar, 
						double ** Weight, int * NWeights);

private:
	double proyectarCentroSobreYCero(VEC2D_double centro);
protected:
	int Grid_Size();
	int Genera_Posiciones();
	int Calculate_SectorWeights(double angle, int *NElements);
	int Prepare_Weigths_Calculation();
	int Extrae_Corners(GridPos * PixelPos);
	int SectoralVoxel_Projection(int NPoints, int *Nelements);

	int Prepare_2D_Proj();
	int Calculate_2D_Proj();
	int Ordena_2D_Proj();
	int Normalize_2D_Proj();
	int releaseVOIto2D();

};

#endif